com.tibbo.aggregate.common.context

## Class VariableDefinition

- java.lang.Object
- - com.tibbo.aggregate.common.context.AbstractEntityDefinition
  - - com.tibbo.aggregate.common.context.VariableDefinition

- All Implemented Interfaces:
    EntityDefinition, java.lang.Cloneable, java.lang.Comparable<VariableDefinition>

      public class VariableDefinition
      extends AbstractEntityDefinition
      implements java.lang.Cloneable, java.lang.Comparable<VariableDefinition>

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `CACHING_HARD`
    `static int` | `CACHING_NONE`
    `static int` | `CACHING_SOFT`
    `static int` | `HISTORY_RATE_ALL`
    `static int` | `HISTORY_RATE_CHANGES`

    - ### Fields inherited from class com.tibbo.aggregate.common.context.AbstractEntityDefinition

      `immutable`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `VariableDefinition(java.lang.String name, TableFormat format, boolean readable, boolean writable)`
    `VariableDefinition(java.lang.String name, TableFormat format, boolean readable, boolean writable, java.lang.String description)`
    `VariableDefinition(java.lang.String name, TableFormat format, boolean readable, boolean writable, java.lang.String description, java.lang.String group)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addCompatibilityConverter(CompatibilityConverter converter)`
    `VariableDefinition` | `clone()`
    `VariableDefinition` | `cloneIfImmutable()`
    `int` | `compareTo(VariableDefinition d)`
    `boolean` | `equals(java.lang.Object obj)`
    `java.lang.Long` | `getChangeEventsExpirationPeriod()`
    `java.util.List<CompatibilityConverter>` | `getCompatibilityConverters()`
    `CompatibilityValidator` | `getCompatibilityValidator()`
    `DataTable` | `getDefaultValue()`
    `java.lang.Integer` | `getEntityType()`
    `TableFormat` | `getFormat()`
    `VariableGetter` | `getGetter()`
    `java.lang.String` | `getHelpId()`
    `java.lang.Integer` | `getHistoryRate()`
    `int` | `getLocalCachingMode()`
    `Permissions` | `getReadPermissions()`
    `java.lang.Long` | `getRemoteCacheTime()`
    `VariableSetter` | `getSetter()`
    `java.lang.Class` | `getValueClass()`
    `Permissions` | `getWritePermissions()`
    `int` | `hashCode()`
    `java.lang.Boolean` | `isAddPreviousValueToVariableUpdateEvent()`
    `boolean` | `isAllowUpdateEvents()`
    `boolean` | `isHidden()`
    `boolean` | `isLocalCachingEnabled()`
    `boolean` | `isPersistent()`
    `boolean` | `isReadable()`
    `boolean` | `isWritable()`
    `void` | `setAddPreviousValueToVariableUpdateEvent(boolean addPreviousValueToVariableUpdateEvent)`
    `void` | `setAllowUpdateEvents(boolean allowUpdateEvents)`
    `void` | `setChangeEventsExpirationPeriod(java.lang.Long changeEventsExpirationPeriod)` Sets duration of update events storage (in milliseconds).
    `void` | `setCompatibilityValidator(CompatibilityValidator compatibilityValidator)`
    `void` | `setDefaultValue(DataTable defaultValue)`
    `void` | `setFormat(TableFormat format)`
    `void` | `setGetter(VariableGetter getter)`
    `void` | `setGroup(java.lang.String group)`
    `void` | `setHelpId(java.lang.String helpId)`
    `void` | `setHidden(boolean hidden)`
    `void` | `setHistoryRate(java.lang.Integer historyRate)`
    `void` | `setLocalCachingMode(int value)`
    `void` | `setPersistent(boolean persistent)`
    `void` | `setReadable(boolean readable)`
    `void` | `setReadPermissions(Permissions readPermissions)`
    `void` | `setRemoteCacheTime(java.lang.Long remoteCacheTime)`
    `void` | `setSetter(VariableSetter setter)`
    `void` | `setValueClass(java.lang.Class valueClass)`
    `void` | `setWritable(boolean writable)`
    `void` | `setWritePermissions(Permissions writePermissions)`
    `boolean` | `storeChangesOnlyInHistory()`

    - ### Methods inherited from class com.tibbo.aggregate.common.context.AbstractEntityDefinition

      `getDescription, getGroup, getHelp, getIconId, getIndex, getName, getOwner, isImmutable, setDescription, setHelp, setIconId, setImmutable, setIndex, setName, setOwner, toDetailedString, toString`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### HISTORY_RATE_CHANGES

          public static final int HISTORY_RATE_CHANGES

      See Also:
        Constant Field Values

    - #### HISTORY_RATE_ALL

          public static final int HISTORY_RATE_ALL

      See Also:
        Constant Field Values

    - #### CACHING_NONE

          public static final int CACHING_NONE

      See Also:
        Constant Field Values

    - #### CACHING_HARD

          public static final int CACHING_HARD

      See Also:
        Constant Field Values

    - #### CACHING_SOFT

          public static final int CACHING_SOFT

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### VariableDefinition

          public VariableDefinition(java.lang.String name,
                                    TableFormat format,
                                    boolean readable,
                                    boolean writable)

    - #### VariableDefinition

          public VariableDefinition(java.lang.String name,
                                    TableFormat format,
                                    boolean readable,
                                    boolean writable,
                                    java.lang.String description)

    - #### VariableDefinition

          public VariableDefinition(java.lang.String name,
                                    TableFormat format,
                                    boolean readable,
                                    boolean writable,
                                    java.lang.String description,
                                    java.lang.String group)

  - ### Method Detail

    - #### setFormat

          public void setFormat(TableFormat format)

    - #### setReadable

          public void setReadable(boolean readable)

    - #### setWritable

          public void setWritable(boolean writable)

    - #### setHidden

          public void setHidden(boolean hidden)

    - #### setGroup

          public void setGroup(java.lang.String group)

      Overrides:
        `setGroup` in class `AbstractEntityDefinition`

    - #### setReadPermissions

          public void setReadPermissions(Permissions readPermissions)

    - #### setWritePermissions

          public void setWritePermissions(Permissions writePermissions)

    - #### setSetter

          public void setSetter(VariableSetter setter)

    - #### setGetter

          public void setGetter(VariableGetter getter)

    - #### getFormat

          public TableFormat getFormat()

    - #### isReadable

          public boolean isReadable()

    - #### isWritable

          public boolean isWritable()

    - #### isHidden

          public boolean isHidden()

    - #### getReadPermissions

          public Permissions getReadPermissions()

    - #### getWritePermissions

          public Permissions getWritePermissions()

    - #### getSetter

          public VariableSetter getSetter()

    - #### getGetter

          public VariableGetter getGetter()

    - #### getHelpId

          public java.lang.String getHelpId()

    - #### setHelpId

          public void setHelpId(java.lang.String helpId)

    - #### getValueClass

          public java.lang.Class getValueClass()

    - #### setValueClass

          public void setValueClass(java.lang.Class valueClass)

    - #### getChangeEventsExpirationPeriod

          public java.lang.Long getChangeEventsExpirationPeriod()

    - #### setChangeEventsExpirationPeriod

          public void setChangeEventsExpirationPeriod(java.lang.Long changeEventsExpirationPeriod)

      Sets duration of update events storage (in milliseconds). Null duration disables update events persistent storage.

    - #### isLocalCachingEnabled

          public boolean isLocalCachingEnabled()

    - #### getLocalCachingMode

          public int getLocalCachingMode()

    - #### setLocalCachingMode

          public void setLocalCachingMode(int value)

    - #### getRemoteCacheTime

          public java.lang.Long getRemoteCacheTime()

    - #### setRemoteCacheTime

          public void setRemoteCacheTime(java.lang.Long remoteCacheTime)

    - #### isAddPreviousValueToVariableUpdateEvent

          public java.lang.Boolean isAddPreviousValueToVariableUpdateEvent()

    - #### setAddPreviousValueToVariableUpdateEvent

          public void setAddPreviousValueToVariableUpdateEvent(boolean addPreviousValueToVariableUpdateEvent)

    - #### getDefaultValue

          public DataTable getDefaultValue()

    - #### setDefaultValue

          public void setDefaultValue(DataTable defaultValue)

    - #### isPersistent

          public boolean isPersistent()

    - #### setPersistent

          public void setPersistent(boolean persistent)

    - #### isAllowUpdateEvents

          public boolean isAllowUpdateEvents()

    - #### setAllowUpdateEvents

          public void setAllowUpdateEvents(boolean allowUpdateEvents)

    - #### getHistoryRate

          public java.lang.Integer getHistoryRate()

    - #### setHistoryRate

          public void setHistoryRate(java.lang.Integer historyRate)

    - #### storeChangesOnlyInHistory

          public boolean storeChangesOnlyInHistory()

    - #### addCompatibilityConverter

          public void addCompatibilityConverter(CompatibilityConverter converter)

    - #### getCompatibilityConverters

          public java.util.List<CompatibilityConverter> getCompatibilityConverters()

    - #### getCompatibilityValidator

          public CompatibilityValidator getCompatibilityValidator()

    - #### setCompatibilityValidator

          public void setCompatibilityValidator(CompatibilityValidator compatibilityValidator)

    - #### clone

          public VariableDefinition clone()

      Overrides:
        `clone` in class `java.lang.Object`

    - #### cloneIfImmutable

          public VariableDefinition cloneIfImmutable()

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### equals

          public boolean equals(java.lang.Object obj)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### compareTo

          public int compareTo(VariableDefinition d)

      Specified by:
        `compareTo` in interface `java.lang.Comparable<VariableDefinition>`

    - #### getEntityType

          public java.lang.Integer getEntityType()

      Specified by:
        `getEntityType` in interface `EntityDefinition`
      Overrides:
        `getEntityType` in class `AbstractEntityDefinition`